<?php

#Основной класс MVCSystem#
#Default MVCSystem class#

class MVCS {
	var $MDL = array();
	
	#Перенос объектов модулей в свойство класса#
	#Moving modules objects in the class property#
	
	function MVCS ($MODLS = false) {
		GLOBAL $cfg;
		if ($MODLS){
				foreach ($MODLS as $MDL_key=>$MDL_val){
					$this->$MDL_key = new $MDL_key;
				}
		}
	}

	#Установка настроек модуля#
	#Installing module settings#

	function Mvcs_set_cfg($cfg_name = false){
		require_once "cfg/default.php";
	
		if ($cfg_name){
			require_once "cfg/$cfg_name.php";
		}
	
		return $cfg;
	}

	#Загрузка модулей по умолчанию#
	#Loading defaut modules#

	function Mvcs_load_modules(){
		GLOBAL $cfg;
		if ($cfg['default_modules']){
			if (is_dir($cfg['modules_directory'])) {
				if ($dh = opendir($cfg['modules_directory'])) {
					while (($file = readdir($dh))) {
						$arg = explode('.',$file);
						if (isset($cfg['default_modules'][$arg[0]])){
							$Modules[$arg[0]] = true;
						}
					}
					closedir($dh);
				}
				return $Modules;
			}else{
				echo '[Mvcs_load_modules():Ошибка|Error]Не найдена директория модулей | Modules directory is not';
			}
		}
	}
	
	#Загрузка модуля#
	#Loading module#
	
	function Mvcs_load_module($name){
	
		GLOBAL $cfg;
		if (is_dir($cfg['modules_directory'])) {
			if ($dh = opendir($cfg['modules_directory'])) {
				while (($file = readdir($dh))) {
					$arg = explode('.',$file);
					if ($file=$name){
						require $cfg['modules_directory'].$name.'.php';
						$this->$name = new $name;
					}
				}
				closedir($dh);
			}
		}else{
			echo '[Mvcs_load_module():Ошибка|Error]Не найдена директория модулей | Modules directory is not';
		}
	
	}

	#Загрузка контроллера#
	#Loading controller#

	function Mvcs_load_controller ($controller,$con_method,$method_args,$MDLS){
		GLOBAL $cfg;
		if (is_dir($cfg['controllers_directory'])){
			require_once $cfg['controllers_directory'].$controller.'.php';
			$_obj = new $controller($MDLS);
			if ($con_method){
				if ($method_args){
					call_user_method_array($con_method,&$_obj,$method_args);
				}else{
					call_user_method($con_method,&$_obj);
				}
			}else{
				if ($method_args){
					call_user_method_array('index',&$_obj,$method_args);
				}else{
					$_obj->index();
				}
			}
		}else{
		
			echo '[Mvcs_load_controller():Ошибка|Error]Не найдена директория контроллеров | Controllers directory is not';
		
		}
	}
	
	#Загрузка модели#
	#Loading model#
	
	function Mvcs_load_model($model){
		GLOBAL $cfg;
		if (is_dir($cfg['models_directory'])){
			require_once $cfg['models_directory'].$model.'.php';
			$MODLS = $this->Mvcs_load_modules();
			$_mdl = new $model($MODLS);
			$this->$model = $_mdl;
		}else{
			
			echo '[Mvcs_load_model():Ошибка|Error]Не найдена директория моделей | Models directory is not';
		
		}
	}
	
	#Загрузка вида#
	#Loading view#
	
	function Mvcs_load_view($view,$args = false){
		GLOBAL $cfg;
		if (is_dir($cfg['views_directory'])){
			if ($args)extract($args);
			require_once $cfg['views_directory'].$view.'.php';
		}else{
			
			echo '[Mvcs_load_view():Ошибка|Error]Не найдена директория видов | Views directory is not';
		
		}
	}
	
	
	#Загрузка библиотеки#
	#Loading library#
	
	function Mvcs_load_library($name){
		GLOBAL $cfg;
		if (is_dir($cfg['libraries_directory'])){
			require_once $cfg['libraries_directory'].$view.'.php';
		}else{
			
			echo '[Mvcs_load_library():Ошибка|Error]Не найдена директория библиотек | Libraries directory is not';
		
		}
	}
	
	
	
		
}