<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01//EN" "http://www.w3.org/TR/html4/strict.dtd">
<html>
	<head>
	 <meta http-equiv="Content-Type" content="text/html; charset=utf-8">
	<title>MVCSystem Framework</title>
	<link rel="stylesheet" type="text/css" href="/style.css">
	</head>
	<body>
	<h1>FAQ по модулям</h1>
	<ul>
		<li><a href="#MVCS_core">MVCS_core</a> - системные функции движка</li>
		<li><a href="#MVCS_database">MVCS_database</a> - для работы с базами данных mysql</li>
		<li><a href="#MVCS_pdo">MVCS_pdo</a> - для работы с PDO</li>
	</ul>
	<h1 id="MVCS_core">MVCS_core</h1><p>
	MVCS() - конструктор класса<br>
	В нем объекты модулей помещаються в свойства, таким образом, чтобы получить доступ к объекту модуля MVCS_database, нужно указать его загрузку через настройки, или загрузить методом Mvcs_load_module()<br>
	И пользоваться на здоровье его методами, пример: $this->MVCS_database->method_name()</p>
	<p>Mvcs_set_cfg() - функция установки параметров, аргументом принимается название файла настроек, без формата, можно использовать в контроллерах в таком виде: $this->Mvcs_set_cfg('file');</p>
	<p>Mvcs_load_modules() - возвращает массив названий модулей, которые инклудяться в файле index.php, а объекты модулей создаются уже в конструкторе MVCS, см.выше</p>
	<p>Mvcs_load_controller() - загружает контроллер, используется в файле index.php, не рекомендую использовать в контроллерах</p>
	<p>Mvcs_load_model() - загрузка моделей, используется в контроллерах. Должен заметить что массивы MDL модели, и MDL контроллера содержат разные экземпляры объектов модулей</p>
	<p>Mvcs_load_view() - загрузка вида, используется контроллером, пример вида:<br>
	<?=htmlspecialchars('
		<html><head>$title</head><body>$text</body></html>
		')?>
	<br>
	Результат: Заголовок страницы изменился на значение переменной $title, и на экран вывелось значение переменной $text<br>
	Чтобы это работало в контроллере я указал следующее:
	 $this->Mvcs_load_view('view',array('title'='Название','text'=>'Текст'));<br>
	Думаю вы поняли как это работает...</p>
	<p>Mvcs_load_module() - загрузка модуля</p>
	<p>Mvcs_load_library() - инклудит файл указанной библиотеки</p>
	<h1 id="MVCS_database">MVCS_database</h1>
	<p>Модуль используется для работы с базой данных<br>
	Использует настройки из массива $cfg['db'] для создания первого подключения при объявлении объекта класса этого модуля<br>
	Особенности модуля: Возможность работать с несколькими подключениями, создавать новые, закрывать их, открывать...<br>
	Свойства:</p>
	<p>var $connection = array(); - массив подключений</p>
	<p>var $connection_properties = array(); - массив с данными о подключениях, хочу заметить, что если вы открыли соединение, потом его закрыли, и хотите снова открыть, то нужно указать только первый аргумент в методе OpenConnection() - имя подключения, т.к данные об этом подключении уже хранятся в свойстве $connect_properties</p>
	<p>var $use_connection; - активное подключение; используется методом Query, для осуществления запроса к активному подключению; для изменения активного подключения используйте метод UseConnection()</p>
	<p>var $use_db; - активная баз данных; не используется в методах; для для изменения базы данных подключения, необходимо использовать метод SetDatabase()</p>
	<p>Методы:</p>
	<p>MVCS_database() - конструктор, используется для создания подключения по умолчанию (при объявлении объекта этого класса(MVCS_pdo)) с именем default;</p>
	<p>CloseConnection() - закрытие подключения, аргумент - имя подключения</p>
	<p>OpenConnection() - создание подключения; аргументы: $name - имя подключения, $host,$user,$password,$char - данные подключения</p>
	<p>SetDatabase() - изменение используемой базы данных, аргумент - название базы</p>
	<p>UseConnection() - изменение активного подключение, аргумент - имя подключения</p>
	<p>Query() - выполнение запроса к активному подключению</p>
	<h1 id="MVCS_pdo">MVCS_pdo</h1>
	<p>Это модуль для работы с <a href="http://www.php.net/manual/ru/book.pdo.php">PDO</a>, для его работы необходимо наличие специальных драйверов на сервере</p>
	<p>Аналогично модулю MVCS_database, при создании объекта этого класса, он выполняет подключение к базе данных используя данные из массива настроек $cfg['db'], но MVCS_database не использует значение параметра $cfg['db']['db_type'], т.к работает исключительно с базами данных MYSQL</p>
	<p>Как и MVCS_database, MVCS_pdo умеет работать с несколькими подключениями, создавать новые, удалять...<br>
	Свойства:</p>
	<p>var $connection = array(); - массив подключений</p>
	<p>var $connection_properties = array(); - массив с данными о подключениях, хочу заметить, что если вы открыли соединение, потом его закрыли, и хотите снова открыть, то нужно указать только первый аргумент в методе OpenConnection() - имя подключения, т.к данные об этом подключении уже хранятся в свойстве $connect_properties</p>
	<p>var $use_connection; - активное подключение; используется почти всемя методами этого класса; для изменения активного подключения используйте метод UseConnection()</p>
	<p>var $prepare; - подготовленный запрос, используется методом Exec(), для выполнения подготовленного запроса</p>
	<p>Методы:</p>
	<p>MVCS_pdo() - конструктор, используется для создания подключения по умолчанию (при объявлении объекта этого класса(MVCS_pdo)) с именем default;</p>
	<p>CloseConnection() - закрытие подключения, аргумент - имя подключения</p>
	<p>OpenConnection() - создание подключения; аргументы: $name - имя подключения, $host,$user,$password,$char - данные подключения;$db_type - тип загружаемого драйвера, то есть тип базы данных, с которой будет вестись работа</p>
	<p>UseConnection() - изменение активного подключение, аргумент - имя подключения</p>
	<p>Prepare() - подготовка запроса; аргументы: $query - запрос, $arr_attr - массив атрибутов(как правильно подготавливать запросы, можно прочитать <a href="http://php.net/manual/ru/pdo.prepare.php">здесь</a>)<br>
	Возвращает экземпляр PDOStatement подготовленного запроса: используйте $prepare_object->execute(array(Init_parameters)), для выполнения подготовленного запроса
	</p>
	<p>SetAttribute() - установка атрибутов активного подключения, аргументы: $attribute - атрибут, $value - значение</p>
	<p>Query() - выполнение запроса к активному подключению, возвращает PDOStatement экземпляр запроса</p>
	<p><a href="<?=$cfg['url']?>">Главная<a> | <a href="/doc/">Док.</a></p>
	</body>
</html>